/*  $RCSfile: euclid.c,v $ */
/*  $Author: nakane $ */
/*  $Date: 1999/12/20 02:56:44 $ */
/*  $Revision: 1.1.1.1 $ */
/*  $State: Exp $ */

#include <stdio.h>

void euclid( int *m, int *n );

int main(int argc, char **argv) {
  int m = 24, n = 36 ;
  int gcm;

  while ( m != 0 && n != 0 ) euclid( &m, &n );
  if      ( m == 0 ) gcm = n;
  else if ( n == 0 ) gcm = m;

  printf ("%d\n",gcm);

  return 0;
}

void euclid( int *m, int *n ) {
  int large, small;

  if ( *m >= *n ) { large = *m ; small = *n ; }
  if ( *m <  *n ) { large = *n ; small = *m ; }
  *m = large - small;
  *n = small;
}
