/*  $RCSfile: map_data.sample1.c,v $ */
/*  $Author: nakane $ */
/*  $Date: 1999/12/20 02:56:43 $ */
/*  $Revision: 1.1.1.1 $ */
/*  $State: Exp $ */

/* ץ map_data ؿ */
#include <assert.h>
#include "map_data.h"

Sfl_mem map_data ( long adr, int bit_no ) {
  Sfl_mem ret;

  assert ( !(adr & 0xfffe0000) );
  assert ( bit_no >= 0 && bit_no < 16 );

  /* ɥ쥹 MSB ߤ. */
  if ( adr & 0x10000 && adr & 0x08000 ) {
    ret.adr = adr - 0x10000;
    ret.unit_no = bit_no + 16 ;
  } else if ( adr & 0x10000 && !(adr & 0x08000 ) ) {
    ret.adr = adr - 0x10000;
    ret.unit_no = bit_no;
  } else if ( !(adr & 0x10000) && adr & 0x08000  ) {
    ret.adr = adr ;
    ret.unit_no = bit_no + 16;
  } else {
    ret.adr = adr ;
    ret.unit_no = bit_no ;
  }
  
  return ret;
}

